variables:
  TF_ROOT: .
  MAVEN_OPTS: -Dmaven.repo.local=./.m2/repository
  

stages:
- build
- plan
- apply
- deploy
- destroy


build:
  image: maven:latest
  stage: build
  script:
    - mvn package -DskipTests=true -Dcheckstyle.skip
    - mv target/*.jar /petclinic.jar
  artifacts:
    paths:
      - ${CI_PROJECT_DIR}/petclinic.jar
  cache:
    paths:
      - ./.m2/repository
  only:
    refs:
      - master


plan:
  image: registry.gitlab.com/gitlab-org/terraform-images/stable:latest
  stage: plan
  script:
    - cd ${TF_ROOT}
    - gitlab-terraform init
    - gitlab-terraform plan
  artifacts:
    paths:
      - ${TF_ROOT}/plan.cache
  needs:
    - build
  only:
    refs:
      - master


apply:
  image: registry.gitlab.com/gitlab-org/terraform-images/stable:latest
  stage: apply
  script:
    - cd ${TF_ROOT}
    - gitlab-terraform apply
  dependencies:
    - plan
  artifacts:
    paths:
      - ${TF_ROOT}/*.tfstate
  needs:
    - plan
  only:
    refs:
      - master

deploy:
  image: registry.gitlab.com/gitlab-org/cloud-deploy/aws-base:latest
  stage: deploy
  script:
    - curl -o kubectl https://amazon-eks.s3.us-west-2.amazonaws.com/1.20.4/2021-04-12/bin/linux/amd64/kubectl
    - chmod +x kubectl
    - mv kubectl /usr/bin/kubectl
    - aws eks --region us-east-2 update-kubeconfig --name ${cluster_name}
    - cd Files/Deployment
    - kubectl create secret generic secrets --from-literal=user=${DBuser} --from-literal=password=${DBpassword} --from-literal=database=${DB}
    - kubectl apply -f ./
    - kubectl apply -f https://github.com/kubernetes-sigs/metrics-server/releases/latest/download/components.yaml
    - kubectl apply -f https://raw.githubusercontent.com/kubernetes/dashboard/v2.0.5/aio/deploy/recommended.yaml
    - cd Dashboard
    - kubectl apply -f eks-admin-service-account.yaml
    - cd ${CI_PROJECT_DIR}
    - sleep 60
    - kubectl get svc petclinic -o yaml | grep hostname | awk '{print $3}'
  dependencies:
     - apply
  needs:
     - apply
  only:
    refs:
      - master


destroy:
  image: registry.gitlab.com/gitlab-org/terraform-images/stable:latest
  stage: destroy
  script:
    - cd ${TF_ROOT}
    - gitlab-terraform destroy
  when: manual
  allow_failure: true
  dependencies:
    - apply
  needs:
    - apply
  only:
    refs:
      - master
